//Baseball WIP
//by Wayne Decatur and Jim Charter
//texture modified from http://news.povray.org/povray.binaries.images/thread/%3C38AFF53B.4A483B33%40stud.ntnu.no%3E/?mtop=12


#include "colors.inc"
#include "textures.inc" 
#include "shapes.inc"    

//************ CAMERA *********

camera { location < 0,0, -40 >  // get closer to <0,0,0> to zoom in on the model
// rotate < 0, 2.000, 0>    //  uncomment to get  left Eye stereo view
//rotate < 90, 0, 0>   //  uncomment to get right Eye stereo view
 direction < 0, 0, 2.836>
 up <0, 1, 0>
 right <640/480, 0, 0>  // **NOTE:** do not forget to adjust this value according to final Width/Height rendering
 look_at <0, 0, 0>
}
//************ LIGHTS *********

#declare Intensity = 3.5  ;
background { color rgb < 1.000, 1.000, 1.000 >} 
object { 
light_source {< 20.000, 20.000, -200.000 > color rgb Intensity*0.550 }

} 



#macro Desaturate ( Color, Factor )

         #local Compliment = <1,1,1>-Color;
         #local Compliment = Compliment*Factor;
         #local NewColor = Color+Compliment;
         #local Numerator = Color.red + Color.green + Color.blue;
         #local Denominator = NewColor.red + NewColor.green + 		 
NewColor.blue;
         #local NewColor = NewColor*Numerator/Denominator;

         NewColor
#end
                                 
               #declare SeamSpline = 
                spline { natural_spline 
                	0/16 <-1.02467078,0.37834672,0.15999313>
                	1/16 <-0.56515695,0.67700611,0.68057811>
                	2/16 <0.18947121,0.81156678,0.74545713>
                	3/16 <0.84952635,0.53278421,0.49407029>
                	4/16 <1.02149677,-0.17962467,0.38139228>
                	5/16 <0.57569966,-0.72816926,0.60946533>
                	6/16 <-0.17852676,-0.81996810,0.73644327>
                	7/16 <-0.84102930,-0.51151050,0.53287799>
                	8/16 <-1.02485357,-0.37812638,-0.15905729>
                	9/16 <-0.57519585,-0.67482599,-0.67448536>
                	10/16 <0.17804369,-0.81262259,-0.74678295>
                	11/16 <0.84237715,-0.53951527,-0.49836613>
                	12/16 <1.02323664,0.16910425,-0.37968600>
                	13/16 <0.58617141,0.72594767,-0.60438623>
                	14/16 <-0.16636486,0.82219849,-0.73632601>
                	15/16 <-0.83353545,0.51630636,-0.54139245>
                	16/16 <-1.02467078,0.37834672,0.15999313>
                };
                
                #local Ball = 
                blob {  threshold .2
                        sphere { <0,0,0>, 1, 1 }
                };
                
                #local Grain = 256;
                #local Strength = 1;   
                #local Radius = .065; 
                
                #local BaseBall = 
                blob {  threshold .15 
                        sphere { <0,0,0>, 1, Strength }
                        #local I=1;#while(I<Grain) 
                        
                                #local Seg = SeamSpline(I/Grain)-SeamSpline((I-1)/Grain);
                                #local Norm = SeamSpline(I/Grain);
                                #local Cross = vcross(Seg,Norm)*4/4;
                                
                                #local Start = Cross+SeamSpline(I/Grain);
                                #local Dir = <0,0,0>-Start;
                                #local Norm = <0,0,0>;
                                #local Pos = trace ( Ball, Start, Dir, Norm ); 
                                #if ( vlength(Norm) != 0 ) 
                                        sphere { 0, Radius, Strength 
                                                translate Pos*.99  
                                                pigment { rgb Cyan } 
                                                finish { ambient .4 } 
                                        } 
                                      
                                #end 
                                
                                #local Start = <0,0,0>-Cross+SeamSpline(I/Grain);
                                #local Dir = <0,0,0>-Start;
                                #local Norm = <0,0,0>;
                                #local Pos = trace ( Ball, Start, Dir, Norm ); 
                                #if ( vlength(Norm) != 0 ) 
                                        sphere { 0, Radius, Strength 
                                                translate Pos*.99  
                                                pigment { rgb Magenta } 
                                                finish { ambient .4 } 
                                        } 
                                      
                                #end  
                                                                                    
                        #local I=I+1;#end
                };
                

# declare ball=
pigment { bozo
    colour_map {
        [0 rgb <255,249,227>/255]
        [0.5 rgb <233,255,227>/255 ]
        [0.8 rgb <219,205,150>/255 ]
        [1 rgb <255,249,227>/255]
               }
        }
 
# declare darkness=
pigment { ripples
    colour_map {
        [0 rgb 1]
        [0.8 rgbf <131,105,55,90>/255 ]
        [1 rgbf 1]
               }
        }
       



                
                object { BaseBall 
                         texture{pigment {ball}}
                         texture{pigment {darkness}}
                         //texture {pigment {Batter}}
                        //texture {pigment {Logo}}
                        //texture {pigment {Major}}
                        finish {specular .1 roughness .05}
                        normal { granite 0.5  scale .001 }
                }